

function [nrz_novi] = dekoder_bez_greske(HDB3)
         duzina = length(HDB3);
         NRZ = zeros(1,duzina);
         znak = 0;
         zero_cnt = 0; %trenutni brojac uzastopnih 0, ide od 0 do 4, kada dodje do 4 nule greska; svaki put kad dodje nula uveca se za 1, a svaki put kada dodje nesto sto nije nula resetuje se
         one_cnt = 0; %brojac koliko je jedinica doslo uzastopno; svaki put kad dodje jedinica istog polariteta uveca se za jedan, svaki put kad dodje suprotnog polariteta postavlja se na 1 jer se sada racuna pojavljivanje te jedinice a svaki put kad dodje 0 ne menja se
         
         buffer = zeros(1,4); %sluzi za 'skladistenje' vrednosti 0 ili 1, iz njega se salje u izlazni niz
         izlaz = zeros(1,duzina+4); %niz koji ce sadrzati NRZ output ali prosiren za 4 mesta jer se na pocetku u baferu nalaze 4 nule koje sluze samo za inicijalizaciju niza
         
         
         function [izl] = insert(ulaz) %pomocna funkcija koja vraca onu vrednost koja se najduze nalazila u baferu 
                 
                 pomocna = buffer(4);
                  if (ulaz ==  2) %oznacava slucaj kada je potrebno 'pregaziti' jedinicu u baferu, npr kada dodje -11001 ne upisujemo prve dve jedinice jer je u pitanju niz od cetiri nule
                     buffer = [0,0,0,0];
                  else %sve u baferu se pomera za jedno mesto, ono sa poslednjeg izbacujemo napolje a na prvo mesto 
                     buffer(4) = buffer(3);
                     buffer(3) = buffer(2);
                     buffer(2) = buffer(1);
                     buffer(1) = ulaz;
                  end
                  [izl] = pomocna;
         end
  
     
         for i = 1 : duzina
             if (HDB3(i) ~= 0) %trenutni znak je ne-nula
                 if ((znak == 0)) | ((znak  ~=   HDB3(i))) %sigurno nije greska jer je ovo prva procitana jedinica
                     znak = HDB3(i);
                     zero_cnt = 0;
                     one_cnt = 1;
                     izlaz(i) = insert(1);
                
                     else %polaritet ove jedinice je isti kao polaritet prosle
                         
                             %nema greske, ovo je slucaj 1001 ili -1000-1
                                 one_cnt = one_cnt+1;
                                 zero_cnt = 0;
                                 izlaz(i) = insert(2); %za slucaj da je u pitanju -100-1 pa sve pretvaramo u 0000
                            
                             
                         
                     
                 end
             else %trenutno je nula
                  %broj uzastopnih nula manji od 3 --> sve ok
                     zero_cnt = zero_cnt+1;
                     izlaz(i) = insert(0);
                 
              end
            end
         
         i = length(HDB3)+1;
             izlaz(i) = insert(0);
             i = i+1;
             izlaz(i) = insert(0);
             i = i+1;
             izlaz(i) = insert(0);
             i = i+1;
             izlaz(i) = insert(0);
             i = i+1;
         
   
         
         [nrz_novi] = izlaz(5:(length(izlaz)));
 
         
   
end
