function [OUT_HDB3] = kod(NRZ)
    duzina = length(NRZ); 			%duzina ulaznog niza
    HDB3 = zeros(1,duzina); 		%izlazni niz se inicijalizuje nulama
    zero_cnt = 0; 				%brojac uzastopnih nula
    one_cnt = 0; 				%brojac regularnih jedinica izmedju dva V bita
    B = 1; V = 1;				%pocetne vrednosti B i V bita
    HDB3_br = 1;				%iterator kroz izlazni niz
    for NRZ_br = 1 : length(NRZ)
        if(NRZ(NRZ_br) == 1)			%provera da li je cifra koja se trenutno obradjuje 1 ili 0
        %jeste regularna jedinica
            HDB3_br = HDB3_br + zero_cnt;	%preskace se manje od 4 nule koje se nalaze pre jedinice, 
%tako da u izlaznom nizu ostaju nule
            zero_cnt = 0;			%resetuje se brojac uzastopnih nula
            HDB3(HDB3_br) = B;	%regularna jedinica dobija odgovarajucu vrednost (B nosi unapred %invertovanu vrednost prosle jedinice)
            HDB3_br = HDB3_br + 1;			
            one_cnt = one_cnt + 1;		%brojac jedinica izmedju 2 V bita se uvecava za jedan
            V = B;								
            B = -1 * B;				%postavljanje vrednosti V i B bita
        else					%jeste nula
            zero_cnt = zero_cnt + 1;
            if(zero_cnt == 4)			%ako je broj uzastopnih nula jednak 4,
%treba utisnuti V i B bite po potrebi
                zero_cnt = 0;			%resetuje se broj uzastopnih nula, nikad nije veci od 4
                if mod(one_cnt,2) == 0 		%provera da li je broj jedinica izmedju zadnja 2 V bita paran	
                    %jeste, pa se utiskuju i V i B biti
                    V = B;
                    HDB3(HDB3_br + 0) = B;	%prvi bit ?etvorke nula dobija vrednost odgovarajuceg B bita
                    HDB3(HDB3_br + 1) = 0;	%drugi bit ?etvorke nula dobija vrednost 0
                    HDB3(HDB3_br + 2) = 0;	%tre?i bit ?etvorke nula dobija vrednost 0 
                    HDB3(HDB3_br + 3) = V;	%?etvrti bit ?etvorke nula dobija vrednost odgovaraju?eg V bita
                    HDB3_br = HDB3_br + 4;
                    B = -1 * B;
                else
                    %nije, pa se utiskuje samo V bit
                    HDB3(HDB3_br + 0) = 0;
                    HDB3(HDB3_br + 1) = 0;
                    HDB3(HDB3_br + 2) = 0;
                    HDB3(HDB3_br + 3) = V;
                    HDB3_br = HDB3_br + 4;
                end
                one_cnt = 0;			%kako se pojavio V bit, resetuje se brojac jedinica izmedju 2 V bita
            end		
        end
    end
    OUT_HDB3 = HDB3;
