

function [p_det,nrz_novi,greska] = dekoder_greska(HDB3_gr)
         duzina = length(HDB3_gr);
         ERROR = zeros(1,duzina);
         NRZ = zeros(1,duzina);
         znak = 0;
         zero_cnt = 0; %trenutni brojac uzastopnih 0, ide od 0 do 4, kada dodje do 4 nule greska; svaki put kad dodje nula uveca se za 1, a svaki put kada dodje nesto sto nije nula resetuje se
         one_cnt = 0; %brojac koliko je jedinica doslo uzastopno; svaki put kad dodje jedinica istog polariteta uveca se za jedan, svaki put kad dodje suprotnog polariteta postavlja se na 1 jer se sada racuna pojavljivanje te jedinice a svaki put kad dodje 0 ne menja se
         
         buffer = zeros(1,4); %sluzi za 'skladistenje' vrednosti 0 ili 1, iz njega se salje u izlazni niz
         izlaz = zeros(1,duzina+4); %niz koji ce sadrzati NRZ output ali prosiren za 4 mesta jer se na pocetku u baferu nalaze 4 nule koje sluze samo za inicijalizaciju niza
         
         
         function [izl] = insert(ulaz) %pomocna funkcija koja vraca onu vrednost koja se najduze nalazila u baferu 
                 
                 pomocna = buffer(4);
                  if (ulaz ==  2) %oznacava slucaj kada je potrebno 'pregaziti' jedinicu u baferu, npr kada dodje -11001 ne upisujemo prve dve jedinice jer je u pitanju niz od cetiri nule
                     buffer = [0,0,0,0];
                  else %sve u baferu se pomera za jedno mesto, ono sa poslednjeg izbacujemo napolje a na prvo mesto 
                     buffer(4) = buffer(3);
                     buffer(3) = buffer(2);
                     buffer(2) = buffer(1);
                     buffer(1) = ulaz;
                  end
                  [izl] = pomocna;
         end
  
     
         for i = 1 : duzina
             if (HDB3_gr(i) ~= 0) %trenutni znak je ne-nula
                 if (znak == 0) %sigurno nije greska jer je ovo prva procitana jedinica
                     znak = HDB3_gr(i);
                     zero_cnt = 0;
                     one_cnt = 1;
                     izlaz(i) = insert(1);
                 else 
                     if (znak  ~=   HDB3_gr(i)) %polaritet ove jedinice je razlicit od prosle, nema greske
                         znak = HDB3_gr(i);
                         zero_cnt = 0;
                         one_cnt = 1;
                         izlaz(i) = insert(1);
                     else %polaritet ove jedinice je isti kao polaritet prosle
                         if (one_cnt >=  2) %vec su se pojavile dve jedinice istog znaka, sada sigurno dolazi do greske
                             if (zero_cnt<3)
                                 HDB3_gr(i) = 0; %pod pretpostavkom da je ova jedinica pogresna, menjamo je sa nulom
                                 ERROR(i) = 1;
                                 zero_cnt = zero_cnt+1;
                                 izlaz(i) = insert(0);
                             else %vec postoje 3 nule za redom, menja se u suprotni polaritet
                                 znak = -1*znak;
                                 HDB3_gr(i) = znak;
                                 ERROR(i) = 1;
                                 zero_cnt = 0;
                                 one_cnt = 1;
                                 izlaz(i) = insert(1);
                             end
                         else %bila samo jedna jedinica tog polariteta pre ove dve
                             if (zero_cnt >=  2) %nema greske, ovo je slucaj 1001 ili -1000-1
                                 one_cnt = one_cnt+1;
                                 zero_cnt = 0;
                                 izlaz(i) = insert(2); %za slucaj da je u pitanju -100-1 pa sve pretvaramo u 0000
                             else %broj nula izmedju dve iste jedinice manji od dva ili veci od 3
                                 ERROR(i) = 1;
                                 HDB3_gr(i) = 0;
                                 zero_cnt = zero_cnt+1;
                                 izlaz(i) = insert(0);
                             end
                         end
                     end
                 end
             else %trenutno je nula
                 if (zero_cnt < 3) %broj uzastopnih nula manji od 3 --> sve ok
                     zero_cnt = zero_cnt+1;
                     izlaz(i) = insert(0);
                 else
                     if (znak ==  0) %usvajamo da se menja sa +1
                         znak = 1;
                         one_cnt = 1;
                         zero_cnt = 0;
                         HDB3_gr(i)=1;
                         ERROR(i) = 1;
                         izlaz(i) = insert(1);
                     else 
                         if (one_cnt >= 2) %slucaj kada su dve susedne jedinice istog polariteta pa trenutnu nulu konvertujemo u -1, npr 1001000 pa dodje 0 --> ide u 1
                             ERROR(i) = 1;
                             HDB3_gr(i) = -1*znak;
                             znak = -1*znak;
                             zero_cnt = 0;
                             one_cnt = 1;
                             izlaz(i) = insert(1);
                         else %susedne jedinice nisu istog znaka, ovu nulu konvertujemo u poslednju jedinicu
                             ERROR(i) = 1;
                             HDB3_gr(i) = znak;
                             one_cnt = one_cnt+1;
                             zero_cnt = 0;
                             izlaz(i) = insert(2);
                         end
                     end
                 end
             end
         end
         i = length(HDB3_gr)+1;
             izlaz(i) = insert(0);
             i = i+1;
             izlaz(i) = insert(0);
             i = i+1;
             izlaz(i) = insert(0);
             i = i+1;
             izlaz(i) = insert(0);
             i = i+1;
             det_cnt = 0;
             for i = 1 : length(ERROR)
                 if ERROR(i) == 1
                     det_cnt = det_cnt + 1;
                 end
             end
             
             
         
   
         [p_det] = det_cnt;
         [nrz_novi] = izlaz(5:(length(izlaz)));
         [greska] = ERROR;
 
         
         
   
end
